// SW24R6Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "SpinTest.h"
#include "SpinTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSW24R6Dlg dialog




CSW24R6Dlg::CSW24R6Dlg(CWnd* pParent /*=NULL*/)
  : CDialog(CSW24R6Dlg::IDD, pParent)
  , pID(0)
//	, SpinBuffer(0)
{
  m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSW24R6Dlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Text(pDX, IDC_ACHSE1, SpinBuffer[0]);
  DDX_Text(pDX, IDC_ACHSE2, SpinBuffer[1]);
  DDX_Text(pDX, IDC_ACHSE3, SpinBuffer[2]);
  DDX_Text(pDX, IDC_ACHSE4, SpinBuffer[3]);
  DDX_Text(pDX, IDC_ACHSE5, SpinBuffer[4]);
  DDX_Text(pDX, IDC_ACHSE6, SpinBuffer[5]);
  DDX_Control(pDX, IDC_BUTTON1, StaticBuffer[0]);
  DDX_Control(pDX, IDC_BUTTON2, StaticBuffer[1]);
  DDX_Control(pDX, IDC_BUTTON3, StaticBuffer[2]);
  DDX_Control(pDX, IDC_BUTTON4, StaticBuffer[3]);
  DDX_Control(pDX, IDC_BUTTON5, StaticBuffer[4]);
  DDX_Control(pDX, IDC_BUTTON6, StaticBuffer[5]);
  DDX_Control(pDX, IDC_BUTTON7, StaticBuffer[6]);
}

BEGIN_MESSAGE_MAP(CSW24R6Dlg, CDialog)
  ON_WM_PAINT()
  ON_WM_QUERYDRAGICON()
  //}}AFX_MSG_MAP
  ON_WM_TIMER()
  ON_WM_CTLCOLOR()
  ON_BN_CLICKED(IDC_RESET, &CSW24R6Dlg::OnBnClickedReset)
END_MESSAGE_MAP()


// CSW24R6Dlg message handlers

BOOL CSW24R6Dlg::OnInitDialog()
{
  CDialog::OnInitDialog();

  // Set the icon for this dialog.  The framework does this automatically
  //  when the application's main window is not a dialog
  SetIcon(m_hIcon, TRUE);			// Set big icon
  SetIcon(m_hIcon, FALSE);		// Set small icon

  // TODO: Add extra initialization here

  spinHandle = SpinKitOpenDevice();
  pID = SpinKitGetProductId(spinHandle);

  //Set the SpinBuffer @ 0
  for(int i = 0; i < 6; i++)
    SpinBuffer[i] = 0;

  SetTimer(IDC_LOOPTIMER, 4, NULL);

  //Select SpinWarrior and Enable needed elemens
  if(pID == SPINKIT_PRODUCT_ID24R4)
  {
    GetDlgItem(IDC_ACHSE1)->EnableWindow(true);
    GetDlgItem(IDC_ACHSE2)->EnableWindow(true);
    GetDlgItem(IDC_ACHSE3)->EnableWindow(true);
    GetDlgItem(IDC_ACHSE4)->EnableWindow(true);

    GetDlgItem(IDC_BUTTON1)->EnableWindow(true);
    GetDlgItem(IDC_BUTTON2)->EnableWindow(true);
    GetDlgItem(IDC_BUTTON3)->EnableWindow(true);
    GetDlgItem(IDC_BUTTON4)->EnableWindow(true);
    GetDlgItem(IDC_BUTTON5)->EnableWindow(true);
    GetDlgItem(IDC_BUTTON6)->EnableWindow(true);
    GetDlgItem(IDC_BUTTON7)->EnableWindow(true);
  }

  if(pID == SPINKIT_PRODUCT_ID24R6)
  {
    GetDlgItem(IDC_ACHSE1)->EnableWindow(true);
    GetDlgItem(IDC_ACHSE2)->EnableWindow(true);
    GetDlgItem(IDC_ACHSE3)->EnableWindow(true);
    GetDlgItem(IDC_ACHSE4)->EnableWindow(true);
    GetDlgItem(IDC_ACHSE5)->EnableWindow(true);
    GetDlgItem(IDC_ACHSE6)->EnableWindow(true);

    GetDlgItem(IDC_BUTTON1)->EnableWindow(true);
    GetDlgItem(IDC_BUTTON2)->EnableWindow(true);
    GetDlgItem(IDC_BUTTON3)->EnableWindow(true);
  }

  if(pID == SPINKIT_PRODUCT_ID24A3)
  {
    GetDlgItem(IDC_ACHSE1)->EnableWindow(true);
    GetDlgItem(IDC_ACHSE2)->EnableWindow(true);
    GetDlgItem(IDC_ACHSE3)->EnableWindow(true);

    GetDlgItem(IDC_BUTTON1)->EnableWindow(true);
    GetDlgItem(IDC_BUTTON2)->EnableWindow(true);
    GetDlgItem(IDC_BUTTON3)->EnableWindow(true);
    GetDlgItem(IDC_BUTTON4)->EnableWindow(true);
    GetDlgItem(IDC_BUTTON5)->EnableWindow(true);
    GetDlgItem(IDC_BUTTON6)->EnableWindow(true);
  }

  if(pID == 0)
  {
    MessageBox("Please connect a SpinWarrior and restart the programm.","Error: No SpinWarrior", NULL);
    KillTimer(IDC_LOOPTIMER);
    SpinKitCloseDevice(spinHandle);
    OnOK();
  }

  //Set font-type for each element
  cFont.CreateFontA(24, 0, 0, 0, FW_NORMAL, FALSE, FALSE, 0, DEFAULT_CHARSET, OUT_CHARACTER_PRECIS, CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, "Arial");

  //Create CStatic-variables for change font
  CStatic *Spin1 = (CStatic*)GetDlgItem(IDC_ACHSE1);
  CStatic *Spin2 = (CStatic*)GetDlgItem(IDC_ACHSE2);
  CStatic *Spin3 = (CStatic*)GetDlgItem(IDC_ACHSE3);
  CStatic *Spin4 = (CStatic*)GetDlgItem(IDC_ACHSE4);
  CStatic *Spin5 = (CStatic*)GetDlgItem(IDC_ACHSE5);
  CStatic *Spin6 = (CStatic*)GetDlgItem(IDC_ACHSE6);

  //Set new font to statics
  Spin1->SetFont(&cFont);
  Spin2->SetFont(&cFont);
  Spin3->SetFont(&cFont);
  Spin4->SetFont(&cFont);
  Spin5->SetFont(&cFont);
  Spin6->SetFont(&cFont);

  return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSW24R6Dlg::OnPaint()
{
  if (IsIconic())
  {
    CPaintDC dc(this); // device context for painting

    SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

    // Center icon in client rectangle
    int cxIcon = GetSystemMetrics(SM_CXICON);
    int cyIcon = GetSystemMetrics(SM_CYICON);
    CRect rect;
    GetClientRect(&rect);
    int x = (rect.Width() - cxIcon + 1) / 2;
    int y = (rect.Height() - cyIcon + 1) / 2;

    // Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
  {
    CDialog::OnPaint();
  }


}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSW24R6Dlg::OnQueryDragIcon()
{
  return static_cast<HCURSOR>(m_hIcon);
}



HBRUSH CSW24R6Dlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
  //Change color for static text

  HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

  if(pWnd->GetDlgCtrlID() == IDC_ACHSE1)
    pDC->SetTextColor(RGB(0,0,150));
    
  if(pWnd->GetDlgCtrlID() == IDC_ACHSE2)
    pDC->SetTextColor(RGB(0,0,150));

  if(pWnd->GetDlgCtrlID() == IDC_ACHSE3)
    pDC->SetTextColor(RGB(0,0,150));

  if(pWnd->GetDlgCtrlID() == IDC_ACHSE4)
    pDC->SetTextColor(RGB(0,0,150));

  if(pWnd->GetDlgCtrlID() == IDC_ACHSE5)
    pDC->SetTextColor(RGB(100,0,0));

  if(pWnd->GetDlgCtrlID() == IDC_ACHSE6)
    pDC->SetTextColor(RGB(100,0,0));

  if(pWnd->GetDlgCtrlID() == IDC_STATIC)
    pDC->SetTextColor(RGB(0,0,0));

  return hbr;
}




void CSW24R6Dlg::OnTimer(UINT_PTR nIDEvent)
{
  //Read from SpinWarrior until no more data available
  while(SpinKitReadNonBlocking(spinHandle,&SpinData))
  {
    //Add incoming data for each spin
    for(int i = 0; i < 6; i++)
      if (pID == SPINKIT_PRODUCT_ID24A3)
        // returns absolute data
        SpinBuffer[i] = SpinData.Spins[i];
      else
        // sum up relative data
        SpinBuffer[i] = SpinBuffer[i] + SpinData.Spins[i];

    //Read button-status for 7 buttons
    for(int k = 0; k < 7; k++)
    {
      //Choose bitmap for display status
      if(SpinData.Buttons[k])
      {
        BitmapBuffer.DeleteObject();
        BitmapBuffer.LoadBitmap(IDB_DOTON);
        StaticBuffer[k].SetBitmap(BitmapBuffer);
      }
      else
      {
        BitmapBuffer.DeleteObject();
        BitmapBuffer.LoadBitmap(IDB_DOTOFF);
        StaticBuffer[k].SetBitmap(BitmapBuffer);
      }
    }
  }

  UpdateData(false);

  CDialog::OnTimer(nIDEvent);
}



void CSW24R6Dlg::OnBnClickedReset()
{
  //Reset spin-count
  for(int i = 0; i < 6; i ++)
    SpinBuffer[i] = 0;
}
